{
Client Access Objects 1.5

Command/Program demo

(c) 1998, 1999 Steven P. Goldsmith
All Rights Reserved

Make sure you change the systemName of the TcaoRemoteCallConversation component
to your system name.

The command and program provided here are for reference only and will not run
on your AS/400.  Modify the required component properties and source before
running.

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 1, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

sgoldsmith@home.com
http://members.home.net/sgoldsmith/
}

unit CmdPgmMain;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls, caoProgram,
  caoCommand, caoRemoteCallConversation, caoErrorMessage, caoCommonUtils,

  // Import type library "Client Access Object Library" before compiling.

  Cwbautsv_TLB;

type
  TMainForm = class(TForm)
    StatusLine: TStatusBar;
    RichEdit1: TRichEdit;
    MainMenu1: TMainMenu;
    Run1: TMenuItem;
    Command1: TMenuItem;
    Program1: TMenuItem;
    caoErrorMessage1: TcaoErrorMessage;
    caoRemoteCallConversation1: TcaoRemoteCallConversation;
    caoCommand1: TcaoCommand;
    caoProgram1: TcaoProgram;
    caoProgram2: TcaoProgram;
    Systemlockout1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Command1Click(Sender: TObject);
    procedure Program1Click(Sender: TObject);
    procedure Systemlockout1Click(Sender: TObject);
    procedure caoCommand1RunCmd(Sender: TObject);
    procedure caoProgram1CallPgm(Sender: TObject);
    procedure caoProgram2CallPgm(Sender: TObject);
    procedure caoRemoteCallConversation1Active(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  StatusLine.SimpleText := Application.Hint;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  caoErrorMessage1.Setup;
  caoRemoteCallConversation1.Active := true;
  caoProgram1.Setup;
  caoProgram2.Setup
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  caoRemoteCallConversation1.Active := false;
end;

{
Run command.  This command may or may not work on your system.  Change the
commandString to a command that will run on your AS/400.
}

procedure TMainForm.Command1Click(Sender: TObject);
begin
  with caoCommand1 do
  begin
    RichEdit1.Lines.Add('RunCmd');
    RunCmd
  end
end;

{
Run program.  You need to change the library, program name and parameters.  This
is provided for reference only and will not run on your AS/400.
}

procedure TMainForm.Program1Click(Sender: TObject);
var
  PgmName: OleVariant;
  FlexMenu: OleVariant;
  Code: OleVariant;
begin
  with caoProgram1 do
  begin
    RichEdit1.Lines.Add('CallPgm');
    PgmName := StrToVarByte('TESTAPP ');
    FlexMenu := StrToVarByte('N');
    Code := StrToVarByte('001');
    AddParm(cwbrcInput or cwbrcTextConvert,8,PgmName);
    AddParm(cwbrcInput or cwbrcTextConvert,1,FlexMenu);
    AddParm(cwbrcInout or cwbrcTextConvert,3,Code);
    CallPgm
  end
end;

{
System lock out test.
}

procedure TMainForm.Systemlockout1Click(Sender: TObject);
var
  SysAvail: OleVariant;
  ParmType: SmallInt;
  ParmLen: Integer;
begin
  with caoProgram2 do
  begin
    RichEdit1.Lines.Add('CallPgm');
    SysAvail := StrToVarByte(' ');
    AddParm(cwbrcInout or cwbrcTextConvert,1,SysAvail);
    CallPgm;
    GetParm(0,ParmType,ParmLen,SysAvail);
    RichEdit1.Lines.Add(Format('System available %s',[VarByteToStr(SysAvail)]))
  end
end;

procedure TMainForm.caoCommand1RunCmd(Sender: TObject);
begin
  RichEdit1.Lines.Add(Format('%s',[caoCommand1.commandString]))
end;

procedure TMainForm.caoProgram1CallPgm(Sender: TObject);
begin
  RichEdit1.Lines.Add(Format('%s',[caoProgram1.programName]))
end;

procedure TMainForm.caoProgram2CallPgm(Sender: TObject);
begin
  RichEdit1.Lines.Add(Format('%s',[caoProgram2.programName]))
end;

procedure TMainForm.caoRemoteCallConversation1Active(Sender: TObject);
begin
  RichEdit1.Lines.Add('OnActive')
end;

end.
